<?php

/*
This makes the buttons for WP 2.1+. It's based on Anarchy Media Player's (http://an-archos.com/anarchy-media-player) button stuff. I've decided to separate it to make it easier for me to modify and maybe for others to borrow.

Quick borrowing howto: Go through this file, replacing 'photopress' with your plugin's name. Read the notes in the functions, especially if you want more than one button. You'll also need to take the 'plugins' folder that should be with this file and modify its contents - create sub-folders based on the example there for each button you need. It'd be nice if someone could work this thing into something like buttonsnap.php, but I don't see a good way what with the stuff in the stupid 'plugins' folder.
*/

// Silly code and function to get the URL for for this file's folder.
require_once(photopress_include_up('wp-config.php'));
$photopress_url = get_settings('siteurl') . '/wp-content/plugins/photopress';

function photopress_include_up($filename) {
   $c=0;
   while(!is_file($filename)) {
      $filename = '../' . $filename;
      $c++;
      if($c==30) {
         echo 'Could not find ' . basename($filename) . '.'; return '';
      }
   }
   return $filename;
}

// Append buttons to editor
function photopress_mce_plugins($plugins) {
	array_push($plugins, "-photopress","bold"); // add more buttons before 'bold'; note that you need to precede your button name with a dash and end the array with bold (for some reason)
	return $plugins;
}
function photopress_mce_buttons($buttons) {
	array_push($buttons, "separator", "photopress"); // nothing special here, just add button names, using separators as needed
	return $buttons;
}
function photopress_external_plugins() {
	global $photopress_url;
	echo 'tinyMCE.loadPlugin("photopress", "'.$photopress_url.'/plugins/photopress/");' . "\n";  // you need one of these for each button - note that you need a matching folder of stuff under 'plugins' for each of these
	return;
}
// Add quicktags for html source editor. To add more buttons, replicate the stuff between the Start and End comments.
function photopress_add_quicktags() {
echo <<<EOT
<script type="text/javascript">
// <![CDATA[
	if(photopressToolbar = document.getElementById("ed_toolbar")){
		var photopressNr, photopressBut, photopressStart, photopressEnd;
		// Start button 1
		photopressStart = '';
		photopressEnd = '';
		photopressNr = edButtons.length;
		edButtons[photopressNr] = new edButton('ed_photopress0','Photos','', '','','-1');
		var photopressBut = photopressToolbar.lastChild;
		while (photopressBut.nodeType != 1){
			photopressBut = photopressBut.previousSibling;
		}
		photopressBut = photopressBut.cloneNode(true);
		photopressToolbar.appendChild(photopressBut);
		photopressBut.value = 'Photos';
		photopressBut.title = 'Upload and insert images';
		photopressBut.onclick = function() {edPhotopress();}
		photopressBut.id = "ed_photopress0";							
		photopressStart = '';
		photopressEnd = '';
		// End button 1
	}

// ]]>
</script>
EOT;
}
// Load the javascript for the popup tool. This runs when the button is clicked - it launches the Photopress popup tool.
function photopress_popup_javascript() {
	global $photopress_url;
	echo '
<script type="text/javascript">
//<![CDATA[
function edPhotopress() {
   var mylink = "' . $photopress_url . '/popup.php?action=upload";
   var windowname = "photopress";
   if (! window.focus) return true;
      var href;
   if (typeof(mylink) == "string")
      href = mylink;
   else
      href = mylink.href;
   ppopupwin = window.open(href, windowname, "width=400,height=600,scrollbars=yes,toolbar=no,menubar=no,resizable=yes");
   ppopupwin.focus();
   return false;
}
//]]>
</script>
';
}

// Actions and filters to connect the plugin with WP.
if (isset($wp_version)) {
	if ($_GET['page'] == 'photopress.php') {
		add_action('admin_head', 'photopress_popup_javascript');
	}
	add_action('edit_form_advanced', 'photopress_popup_javascript');
	add_action('edit_page_form', 'photopress_popup_javascript');
	add_filter("mce_plugins", "photopress_mce_plugins", 10);
	add_filter("mce_buttons", "photopress_mce_buttons", 10);
	add_action('tinymce_before_init','photopress_external_plugins');
	add_action('admin_footer', 'photopress_add_quicktags');
}

?>
